unit RSANewKeyDM;

interface

uses
  SysUtils, Classes, MPComponents, AppEvnts, MPYarrow, Windows;

type
  TdmRSANewKey = class(TDataModule)
    p_gen: TMPPrime;
    q_gen: TMPPrime;
    ptrigger: TMPCondition;
    NLoop: TMPCondition;
    NNew: TMPMulMod;
    One: TMPValue;
    p1: TMPSubMod;
    q1: TMPSubMod;
    p1q1: TMPMulMod;
    e3: TMPValue;
    d3: TMPInvMod;
    e17: TMPValue;
    d17: TMPInvMod;
    e65537: TMPValue;
    d65537: TMPInvMod;
    ernd: TMPRandom;
    etrigger: TMPCondition;
    drnd: TMPInvMod;
    gcdp1q1: TMPGCD;
    lcmp1q1: TMPDivMod;
    qtrigger: TMPCondition;
    gcdpq: TMPGCD;
    p_0: TMPResult;
    p: TMPResult;
    q: TMPResult;
    MPProc1: TMPProc;
    ApplicationEvents1: TApplicationEvents;
    MPYarrow1: TMPYarrow;
    procedure DataModuleDestroy(Sender: TObject);
    procedure MPChange(Sender: TObject);
    procedure MPChanging(Sender: TObject);
    procedure MPIterate(Sender: TObject);
    procedure MPEvaluate(Sender: TObject);
    procedure MPCheck(Sender: TObject; Argument: TMPValue;
      var Result: Boolean);
    procedure MPProc1Changing(Sender: TObject);
    procedure ApplicationEvents1Message(var Msg: tagMSG;
      var Handled: Boolean);
  private
    FLog: TStrings;
    FLevelsSet: Boolean;
    procedure SetLevels;
  public
    property Log: TStrings read FLog;
  end;

var
  dmRSANewKey: TdmRSANewKey;

implementation

{$R *.dfm}

procedure TdmRSANewKey.DataModuleDestroy(Sender: TObject);
begin
  FLog.Free;
end;

procedure TdmRSANewKey.MPChange(Sender: TObject);
var
  Indent: string;
begin
  if FLog = nil then
    FLog := TStringList.Create;
  Indent := StringOfChar(' ',TComponent(Sender).Tag);
  FLog.Add(Indent + TComponent(Sender).Name + ' changed.');
end;

procedure TdmRSANewKey.MPChanging(Sender: TObject); 
var
  Indent: string;
begin
  if FLog = nil then
    FLog := TStringList.Create;
  if not FLevelsSet then SetLevels;
  Indent := StringOfChar(' ',TComponent(Sender).Tag);
  FLog.Add(Indent + TComponent(Sender).Name + ' changing.');
end;

procedure TdmRSANewKey.MPIterate(Sender: TObject);  
var
  Indent: string;
begin
  if FLog = nil then
    FLog := TStringList.Create;
  Indent := StringOfChar(' ',TComponent(Sender).Tag);
  FLog.Add(Indent + TComponent(Sender).Name + ' iterating.');
end;

procedure TdmRSANewKey.MPEvaluate(Sender: TObject);   
var
  Indent: string;
begin
  if FLog = nil then
    FLog := TStringList.Create;
  Indent := StringOfChar(' ',TComponent(Sender).Tag);
  FLog.Add(Indent + TComponent(Sender).Name + ' evaluated.');
end;

procedure TdmRSANewKey.MPCheck(Sender: TObject; Argument: TMPValue;
  var Result: Boolean);   
var
  Indent: string;
begin
  if FLog = nil then
    FLog := TStringList.Create;
  Indent := StringOfChar(' ',TComponent(Sender).Tag);
  if Result then
    FLog.Add(Indent + TComponent(Sender).Name + ' condition OK.')
  else
    FLog.Add(Indent + TComponent(Sender).Name + ' condition failed.');
end;

procedure TdmRSANewKey.SetLevels;
var
  I: Integer;
begin
  for I := 0 to ComponentCount - 1 do
    if Components[I] is TMPBase then
      Components[I].Tag := TMPBase(Components[I]).Level;
  FLevelsSet := True;
end;

procedure TdmRSANewKey.MPProc1Changing(Sender: TObject);
begin
  FLog.Clear;
end;

procedure TdmRSANewKey.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
begin
  MPYarrow1.Accumulate(Msg,SizeOf(Msg),0,0);
end;

end.
